(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
           Programme d'exemple pour l'unit Xms (mmoire tendue).          
*)

{$M 2048,0,0}

uses Convert,Clavier,EcranTxt,Xms;

var
  HandleXms: Word;                     { Handle de la zone mmoire alloue   }

begin
  EffaceEcranTxt;

  { Vrifie la prsence du driver XMS }
{****************************************************************************}
  VerifiePresenceXms;
{****************************************************************************}
  EcriTcr ('Driver XMS dtect !',15);
  SauteLigne;

  { Affiche la version du driver }
  Ecrit ('Version du driver              : '); CoulTxt := 10;
{****************************************************************************}
  EcriTn (hi(VersionXms)); Ecrit ('.'); EcriTn (lo(VersionXms)); CoulTxt := 7;
  Ecrit (' (rvision '); EcriTnc (VersionRevXms,10); EcriTr (')');
{****************************************************************************}

  { Affiche la mmmoire libre }
  Ecrit ('Mmoire libre                  : ');
{****************************************************************************}
  EcriTnc (MemXmsLibre,10);
{****************************************************************************}
  EcriTr (' Ko');

  { Affiche la taille du plus gros bloc libre }
  Ecrit ('Taille du plus gros bloc libre : ');
{****************************************************************************}
  EcriTnc (LitTailGrosBlocXmsLibre,10);
{****************************************************************************}
  EcriTr (' Ko');
  SauteLigne;

  { Alloue un bloc de 100 Ko }
  Ecrit ('Alloue un bloc de 100Ko : ');
{****************************************************************************}
  HandleXms := AlloueMemXms(100); { Attempt to allocate 100k of XMS.     }
{****************************************************************************}

  if ErreurXms<>0 then begin
    EcriTc ('ERREUR',14+4*16); EcriTr (' (code '+Hex8(ErreurXms)+')');
    EcriTc ('> ',15); EcriTc (TxtErreurXms,12); EcriTr ('.');
    SauteLigne;
    Halt (8);
  end else EcriTcr ('Bloc allou sans erreur',15);
  SauteLigne;

  { Copie l'cran dans le bloc }
  Ecrit ('Copie l''cran dans le bloc allou : ');
  with CopieXms do begin
    Taille := 80*25*2;                 { Taille  copier                     }

    { Source }
    SrcHdl := 0;                       { =0, dans ce cas 'SrcOfs' contient   }
                                       { une adresse physique (du type       }
                                       { SEGMENT:OFFSET classique)           }
    SrcOfs := $B8000000;               { Adresse = B800:0000 (mmoire vido  }
                                       { en mode texte)                      }

    { Destination }
    DstHdl := HandleXms;               { Handle de notre bloc                }
    DstOfs := 0;                       { Offset = 0 -> Dbut du bloc         }
  end;
{****************************************************************************}
  CopieMemXms(CopieXms);
{****************************************************************************}

  if ErreurXms<>0 then begin
    EcriTc ('ERREUR',14+4*16); EcriTr (' (code '+Hex8(ErreurXms)+')');
    EcriTc ('> ',15); EcriTc (TxtErreurXms,12); EcriTr ('.');
    SauteLigne;

    EcriTr ('Libre le bloc allou.');
{****************************************************************************}
    RendMemXms (HandleXms);
{****************************************************************************}
    SauteLigne;

    Halt (8);
  end else EcriTcr ('Mmoire copie sans erreur',15);
  SauteLigne;

  { Sauve la position du curseur }
  SauvePosCurTxt;

  EcriTc ('Pressez ENTREE pour continuer : ',14); LitTouche; EffaceLigneTxt;

  { Cre un nouvel cran }
  EffaceEcranChr ('@',1);
  SauteLigne;
  EcriTcr ('L''cran a t effac ! ',15);
  SauteLigne;
  EcriTc ('Pressez ENTREE pour restaurer l''cran : ',14); LitTouche;

  { Remet l'ancien cran }
  with CopieXms do begin
{    Taille := 80*25*2;                 { La taille est inchange            }

    SrcHdl := DstHdl;                   { Echange la source et la destination}
    SrcOfs := DstOfs;                   { (destination = bloc allou)        }

    DstHdl := 0;                        { Nouvelle destination = Ecran texte }
    DstOfs := $B8000000;
  end;
  CopieMemXms(CopieXms);
  if ErreurXms<>0 then begin
    EffaceEcranTxt;
    EcriTc ('ERREUR',14+4*16); EcriTr (' (code '+Hex8(ErreurXms)+')');
    EcriTc ('> ',15); EcriTc (TxtErreurXms,12); EcriTr ('.');
    SauteLigne;
    EcriTr ('Libre le bloc allou.');
    RendMemXms (HandleXms);
    SauteLigne;

    LitTouche;

    Halt (8);
  end;

  { Remet la position du curseur }
  RemetPosCurTxt;

  EcriTcr ('Libre le bloc allou.',15);
  RendMemXms (HandleXms);

  LitTouche;
end.